scriptName zzTestScript extends ActiveMagicEffect


Keyword property HeavyArmorKeyword auto

Spell property SpellHeavyArmorFlag auto

Actor selfRef

Armor cuirass

Armor gauntlets

Armor helmet

Armor circlet

Armor forearms

Armor calves

Armor shield

Armor boots

Int count





Event OnEffectStart(Actor Target, Actor Caster)

    selfRef = Target

    CountHeavyArmor()

EndEvent



Event OnEffectFinish(Actor Target, Actor Caster)

    selfRef.RemoveSpell(SpellHeavyArmorFlag)

EndEvent



Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)

    CountHeavyArmor()

EndEvent



Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)

    CountHeavyArmor()

EndEvent



Function CountHeavyArmor()

    count = 0

    String test = "";

    cuirass = selfRef.GetWornForm(0x00000004) as Armor

    gauntlets = selfRef.GetWornForm(0x00000008) as Armor

    helmet = selfRef.GetWornForm(0x00000001) as Armor

    circlet = selfRef.GetWornForm(0x00001000) as Armor
    
    forearms = selfRef.GetWornForm(0x00000010) as Armor
    
    calves = selfRef.GetWornForm(0x00000100) as Armor
    
    shield = selfRef.GetWornForm(0x00000200) as Armor

    boots = selfRef.GetWornForm(0x00000080) as Armor

    

    if(cuirass.HasKeyword(HeavyArmorKeyword))

        count = count + 1;

    endif

    if(gauntlets.HasKeyword(HeavyArmorKeyword))

        count = count + 1;

    endif

    if(helmet.HasKeyword(HeavyArmorKeyword))

        count = count + 1;

    endif

    if(circlet.HasKeyword(HeavyArmorKeyword))

        count = count + 1;

    endif
    
    if(forearms.HasKeyword(HeavyArmorKeyword))

        count = count + 1;

    endif
    
    if(calves.HasKeyword(HeavyArmorKeyword))

        count = count + 1;

    endif
    
    if(shield.HasKeyword(HeavyArmorKeyword))

        count = count + 1;

    endif

    if(boots.HasKeyword(HeavyArmorKeyword))

        count = count + 1;

    endif

    

    if(count >= 4)

        selfRef.AddSpell(SpellHeavyArmorFlag, false)

    else

        selfRef.RemoveSpell(SpellHeavyArmorFlag)        

    endif

EndFunction